package src

import (
	"acme-client/src/crypto"
	"crypto/aes"
	"crypto/cipher"
	"crypto/rand"
	"encoding/base64"
	"encoding/hex"
	"github.com/go-acme/lego/v4/log"
	"math/big"
)

const charset = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"

func randomStr(length int) string {
	b := make([]byte, length)
	for i := range b {
		randomIndex, _ := rand.Int(rand.Reader, big.NewInt(int64(len(charset))))
		b[i] = charset[randomIndex.Int64()]
	}
	return string(b)
}

func GenToken() (token string, encryptToken string) {
	token = randomStr(32)
	key := GetClientConfig().RsaPublicKey

	tokenBytes, err := crypto.EncryptRSABase64(key, []byte(token))
	if err != nil {
		log.Fatal("Error encrypting data:", err)
	}
	//encryptToken = base64.StdEncoding.EncodeToString(tokenBytes)
	encryptToken = hex.EncodeToString(tokenBytes)

	//keyBytes, err := base64.StdEncoding.DecodeString(key)
	//if err != nil {
	//	log.Fatal("Error decoding public key:", err)
	//}
	//pubKey, err := x509.ParsePKCS1PublicKey(keyBytes)
	//if err != nil {
	//	log.Fatal("Error parsing public key:", err)
	//}
	//
	//enToken, err := rsa.EncryptOAEP(sha256.New(), rand.Reader, pubKey, []byte(token), nil)
	//if err != nil {
	//	log.Fatal("Error encrypting data:", err)
	//}
	//encryptToken = base64.StdEncoding.EncodeToString(enToken)
	return
}

func DecryptByToken(token string, data string) string {
	// 使用 token 进行 DES 解密
	key := []byte(token)
	dataBytes, err := base64.StdEncoding.DecodeString(data)
	if err != nil {
		log.Fatal("Error decoding data:", err)
	}

	block, err := aes.NewCipher(key)
	if err != nil {
		log.Fatal("Error creating cipher:", err)
	}

	if len(dataBytes) < aes.BlockSize {
		log.Fatal("ciphertext too short")
	}

	iv := dataBytes[:aes.BlockSize]
	dataBytes = dataBytes[aes.BlockSize:]

	mode := cipher.NewCBCDecrypter(block, iv)
	mode.CryptBlocks(dataBytes, dataBytes)
	return string(dataBytes)
}
